import { Model, ModelStatic, FindOptions, IncludeOptions, Transaction } from "sequelize";
import { PaginationResponse } from "../types/response.type";
export declare class BaseRepository<T extends Model> {
    private readonly model;
    constructor(model: ModelStatic<T>);
    findOne: (filter?: FindOptions) => Promise<T | null>;
    findAll: (filter?: FindOptions) => Promise<T[]>;
    create: (data: Partial<T>, includeModels?: IncludeOptions[], transaction?: Transaction) => Promise<T>;
    bulkCreate: (data: Partial<T>[], includeModels?: IncludeOptions[]) => Promise<T[]>;
    update: (id: number, data: Partial<T>) => Promise<void>;
    delete: (ids: number[]) => Promise<void>;
    paginate: (page?: number, limit?: number, filter?: FindOptions<T>) => Promise<PaginationResponse<T>>;
}
