import { Model, IncludeOptions, FindOptions, Transaction } from "sequelize";
import { PaginationResponse } from "../types/response.type";
import { BaseRepository } from "../repositories/base.repository";
export declare class BaseLogic<T extends Model> {
    private readonly baseRepo;
    private readonly modelName;
    constructor(baseRepo: BaseRepository<T>, modelName: string);
    findOne: (filter?: FindOptions) => Promise<T>;
    findAll: (filter?: FindOptions) => Promise<T[]>;
    create: (data: Partial<T>, includeModels?: IncludeOptions[], transaction?: Transaction) => Promise<T>;
    bulkCreate: (data: Partial<T>[], includeModels?: IncludeOptions[]) => Promise<T[]>;
    update: (id: number, data: Partial<T>) => Promise<void>;
    delete: (ids: number[]) => Promise<void>;
    paginate: (page?: number, limit?: number, filter?: FindOptions<T>) => Promise<PaginationResponse<T>>;
}
